﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AppFx.DownloadStream.CRM.Tests
{
    [TestClass]
    public class StreamedCrmDownloadTests
    {
        [TestMethod]
        public void StreamedCrmDownloadTest()
        {
            const string outputFile = "Text.txt";

            if (File.Exists(outputFile))
                File.Delete(outputFile);

            var crmConnectionString = "Url=https://[TBC].crm5.dynamics.com; Username=[TBC]@[TBC].onmicrosoft.com; Password=[TBC];";
            var fetchXml = Properties.Resources.FetchXmlExample;

            var crmDownloader = new CrmDownloader(crmConnectionString, fetchXml);
            crmDownloader.FetchCount = 50;
            crmDownloader.MessageStart = "<CrmExtract>";
            crmDownloader.MessageEnd = "</CrmExtract>";
            
            var downloadStream = new GenericDownloadStream(crmDownloader);            
            using (var fs = new FileStream(outputFile, FileMode.Create, FileAccess.Write))
            {
                var index = 0;
                var charsRead = 0;
                while (true)
                {
                    byte[] buffer = new byte[1024];
                    charsRead = downloadStream.Read(buffer, index, 1024);
                    index = index + charsRead;
                    if (charsRead > 0)
                    {
                        fs.Write(buffer, 0, charsRead);
                        fs.Flush();
                    }
                    else
                        break;
                }
            }            
        }
    }
}

